chcp 65001 >NUL
@echo OFF
setlocal enabledelayedexpansion


:Start

cls
echo ---------------------------------------
echo --- AGTP^+ for CaveStory^+ installer ----
echo ---------------------------------------
echo.


rem Check if installers and game files present

set files=agtp^+4E-unip agtp^+-unip classic^+4E-unip classic^+-unip sw_apo-unip data

(for %%b in (%files%) do ( 
	if not exist %%b ( goto MissingFiles )
))

if not exist CaveStory^+.exe (
	if not exist CS^+.exe (
		goto MissingFiles
	)
)

rem Installation choices

call run-unip.bat s agtp^+-unip
call run-unip.bat s agtp^+4E-unip

echo Please choose which version of the game you'd like to play:
echo.
echo 1. Default CaveStory with AGTP^+ translation
echo 2. CaveStory including HaydenStudios' 4 Endings mod with AGTP^+ translation
set choice=
echo.
set /p choice=Type the corresponding number: 
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%'=='1' goto SetDefault
if '%choice%'=='2' goto Set4E
echo "%choice%" is not valid, try again
echo.
goto Start

:ChooseGraphics

cls
echo ---------------------------------------
echo --- AGTP^+ for CaveStory^+ installer ----
echo ---------------------------------------
echo.


call run-unip.bat s classic^+-unip

echo Please choose which graphics you'd like to play with:
echo.
echo 1. CaveStory^+ default graphics 
echo 2. Enhanced original CaveStory graphics
set choice=
echo.
set /p choice=Type the corresponding number: 
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%'=='1' goto SetNoClassic
if '%choice%'=='2' goto SetClassicPlus
echo "%choice%" is not valid, try again
echo.
goto ChooseGraphics

:SetApo

cls
echo ---------------------------------------
echo --- AGTP^+ for CaveStory^+ installer ----
echo ---------------------------------------
echo.


call run-unip.bat s sw_apo-unip

echo Please choose whether you prefer single width apostrophes:
echo.
echo 1. Use default CaveStory^+ font
echo 2. Use single width apostrophes
set choice=
echo.
set /p choice=Type the corresponding number: 
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%'=='1' goto SetDefaultApo
if '%choice%'=='2' goto SetSingleApo
echo "%choice%" is not valid, try again
echo.
goto SetApo


:SetExtract

cls
echo ---------------------------------------
echo --- AGTP^+ for CaveStory^+ installer ----
echo ---------------------------------------
echo.

rem Comment out extract only as some combinations would fail due to dependencies 

echo Please choose whether to install, extract, or both:
echo.
echo 1. Install these patches to my CaveStory^+ installation 
echo 2. Install these patches and extract them as plain files for local backup
rem echo 3. Only extract these patches as plain files for local backup
set choice=
echo.
set /p choice=Type the corresponding number: 
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%'=='1' goto InstallOnly
if '%choice%'=='2' goto InstallExtract
rem if '%choice%'=='3' goto ExtractOnly
echo "%choice%" is not valid, try again
echo.
goto SetExtract


:ConfirmStep
cls
echo ---------------------------------------
echo --- AGTP^+ for CaveStory^+ installer ----
echo ---------------------------------------
echo.

echo You have chosen to !iestring! !gamestring! with !graphicsstring!!swstring!.
echo.

set choice=N
set /p choice=Is this correct (Y/[N])^?
if /i not '%choice%'=='Y' goto AbortInstall


rem Chain all the installs now

rem AGTP+ section
if !version!==default (
	if !extract!==1 (
		call run-unip.bat extract agtp^+-unip
		pause
	)
	if !install!==1 (
		call run-unip.bat install agtp^+-unip
		pause
	)
)

if !version!==4E (
	if !extract!==1 (
		call run-unip.bat extract agtp^+4E-unip
		pause
	)
	if !install!==1 (
		call run-unip.bat install agtp^+4E-unip
		pause
	)
)

rem Classic+ section

if !graphics!==classic^+ (
	if !version!==default (
		if !extract!==1 (
			call run-unip.bat extract classic^+-unip
			pause
		)
		if !install!==1 (
			call run-unip.bat install classic^+-unip
			pause
		)
	)
	if !version!==4E (
		if !extract!==1 (
			call run-unip.bat extract classic^+4E-unip
			pause
		)
		if !install!==1 (
			call run-unip.bat install classic^+4E-unip
			pause
		)
	)
)

rem Single-width apostrophe section

if !swapo!==1 (
	if !extract!==1 (
			call run-unip.bat extract sw_apo-unip
			pause
		)
	if !install!==1 (
			call run-unip.bat install sw_apo-unip
	)
)

echo.
echo Finished installing selection.
goto End


:InstallOnly
set install=1
set extract=0
set iestring=install
goto ConfirmStep

:InstallExtract
set install=1
set extract=1
set iestring=install and extract
goto ConfirmStep

:ExtractOnly
set install=0
set extract=1
set iestring=extract
goto ConfirmStep

:SetSingleApo
set swapo=1
set swstring= and single width apostrophes
goto SetExtract

:SetDefaultApo
set swapo=0
set swstring=
goto SetExtract

:SetNoClassic
set graphics=default
set graphicsstring=default graphics
goto SetApo

:SetClassicPlus
set graphics=classic^+
set graphicsstring=classic^+ graphics
goto SetApo

:SetDefault
set version=default
set gamestring=AGTP^+
goto ChooseGraphics

:Set4E
set version=4E
set gamestring=AGTP^+4E
goto ChooseGraphics

:MissingFiles
echo.
echo Please make sure the unip folders and this script are extracted to your CaveStory^+ root directory (same folder as the game executable file).
goto End

:AbortInstall
echo.
echo Aborting...
goto End


:End
echo.
pause